//+------------------------------------------------------------------+
//|                                                          www.mq4 |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+

#property  indicator_separate_window
#property  indicator_buffers 5
#property  indicator_color1  clrNONE
#property  indicator_color2  RoyalBlue
#property  indicator_color3  Red
#property  indicator_color4  White
#property  indicator_color5  Blue
#property  indicator_width4 3
#property  indicator_width5 2
extern  int Fast   = 12;
extern  int Slow   = 26;
extern  int Signal =1;
extern  int Signal2=9;
extern  int SignalShift=0;
extern  int SignalShift2=0;
extern  bool EnableSignalLineAlert = true;
extern  bool EnableZeroLineCrossoverAlert = true;

//---- indicator buffers
double     ExtBuffer0[];
double     ExtBuffer1[];
double     ExtBuffer2[];
double     SignalBuffer[];
double     SignalBuffer2[];
int a=0,b=0,c=0,d=0,e=0,f=0;

int           Chart_Scale,j,n,Bar_Width; 
bool          Deinitialized;
bool          Alert_Allowed;
static bool   allow = true;
static bool   disallow = false;        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  Deinitialized = false;   
  
  //Determine the current chart scale (chart scale number should be 0-5)
  Chart_Scale = ChartScaleGet();
  
  //Set bar widths             
        if(Chart_Scale == 0) {Bar_Width = 1;}
  else {if(Chart_Scale == 1) {Bar_Width = 2;}      
  else {if(Chart_Scale == 2) {Bar_Width = 2;}
  else {if(Chart_Scale == 3) {Bar_Width = 3;}
  else {if(Chart_Scale == 4) {Bar_Width = 6;}
  else {Bar_Width = 13;} }}}}
  
  
   //---- drawing settings
   SetIndexStyle(0,DRAW_NONE);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,Bar_Width);
   SetIndexStyle(2,DRAW_HISTOGRAM,0,Bar_Width);
   SetIndexStyle(3,DRAW_LINE,STYLE_SOLID);
   SetIndexShift(3, SignalShift); 
   SetIndexStyle(4,DRAW_LINE,STYLE_SOLID);
   SetIndexShift(4, SignalShift2); 
   
   IndicatorDigits(Digits+1);
   SetIndexDrawBegin(0,34);
   SetIndexDrawBegin(1,34);
   SetIndexDrawBegin(2,34);
   SetIndexDrawBegin(3,34);
   SetIndexDrawBegin(4,34);
//---- 3 indicator buffers mapping
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,SignalBuffer);
   SetIndexBuffer(4,SignalBuffer2);
//---- name for DataWindow and indicator subwindow label
  // IndicatorShortName("AO");
   SetIndexLabel(1,NULL);
   SetIndexLabel(2,NULL);
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Awesome Oscillator                                               |
//+------------------------------------------------------------------+
int start()
  {
   int    limit;
   int    i1,limit1;
   int    counted_bars=IndicatorCounted();
   double prev,current;
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit =Bars-counted_bars;
   limit1=Bars-counted_bars;
//---- macd
   for(int i=0; i<limit; i++)
      ExtBuffer0[i]=iMA(NULL,0,Fast,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,Slow,0,MODE_SMA,PRICE_MEDIAN,i);
//---- dispatch values between 2 buffers
   bool up=true;
   for(i=limit-1; i>=0; i--)
     {
      current=ExtBuffer0[i];
      prev=ExtBuffer0[i+1];
      if(current>prev) up=true;
      if(current<prev) up=false;
      if(!up)
        {
         ExtBuffer2[i]=current;
         ExtBuffer1[i]=0.0;
        }
      else
        {
         ExtBuffer1[i]=current;
         ExtBuffer2[i]=0.0;
        }
     }
// ----- Draw signal
    for(i=0; i<limit; i++)
         SignalBuffer [i] =iMAOnArray (ExtBuffer0 ,Bars,Signal ,0,MODE_LWMA,i);
    for(i1=0; i1<limit1; i1++)
         SignalBuffer2[i1] =iMAOnArray (SignalBuffer ,Bars,Signal2,0,MODE_LWMA,i1);
         
    if(EnableSignalLineAlert)
    {
       if(ExtBuffer0[0]<SignalBuffer[0] && ExtBuffer0[1]>=SignalBuffer[1] && Bars>a)
       {
         Alert(Symbol()+" Period "+Period()+" Awesome Signal (SELL)");
         a = Bars;
       }
       
       if(ExtBuffer0[0]>SignalBuffer[0] && ExtBuffer0[1]<=SignalBuffer[1] && Bars>b)
       {
         Alert(Symbol()+" Period "+Period()+" Awesome Signal (BUY)");
         b = Bars;
       } 
       
       
       if(ExtBuffer0[0]<SignalBuffer2[0] && ExtBuffer0[1]>=SignalBuffer2[1] && Bars>c)
       {
         Alert(Symbol()+" Period "+Period()+" Awesome Signal (SELL)");
         c = Bars;
       }
       if(ExtBuffer0[0]>SignalBuffer2[0] && ExtBuffer0[1]<=SignalBuffer2[1] && Bars>d)
       {
         Alert(Symbol()+" Period "+Period()+" Awesome Signal (BUY)");
         d = Bars;
       } 
    }     
    
    if(EnableZeroLineCrossoverAlert)
    {
       if(ExtBuffer0[0]<0 && ExtBuffer0[1]>=0 && Bars>e)
       {
         Alert(Symbol()+" Period "+Period()+" Awesome CROSSED ZERO LINE (SELL)");
         e = Bars;
       }
       
       if(ExtBuffer0[0]>0 && ExtBuffer0[1]<=0 && Bars>f)
       {
         Alert(Symbol()+" Period "+Period()+" Awesome CROSSED ZERO LINE (BUY)");
         f = Bars;
       }
       
    }
         
//---- done
   return(0);
  }
//+------------------------------------------------------------------+
//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Set up to get the chart scale number                                         |
//+-------------------------------------------------------------------------------------------+
void OnChartEvent(const int id, const long &lparam, const double &dparam, const string &sparam)                                                    
  {
  Chart_Scale = ChartScaleGet();
  if(Alert_Allowed == allow)
    {
    init();
    Alert_Allowed = allow;
    }
  else
    {
    init();
    Alert_Allowed = disallow;
    }          
  }

//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  }
    
//+-------------------------------------------------------------------------------------------+
//|Custom indicator end                                                                       |
//+-------------------------------------------------------------------------------------------+    

